Tests: event notifier error counters
[lttng-tools.git] / tests / utils / utils.sh
index 854bae5d2bac49f81fba140e4903e39c3deee1c8..4ef4c72645b39294fada49b4eaf60c71efc91da4 100644 (file)
@@ -1,24 +1,16 @@
-#!/src/bin/bash
+# Copyright (C) 2012 David Goulet <dgoulet@efficios.com>
 #
-# Copyright (C) - 2012 David Goulet <dgoulet@efficios.com>
+# SPDX-License-Identifier: LGPL-2.1-only
 #
-# This library is free software; you can redistribute it and/or modify it under
-# the terms of the GNU Lesser General Public License as published by the Free
-# Software Foundation; version 2.1 of the License.
-#
-# This library is distributed in the hope that it will be useful, but WITHOUT
-# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
-# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
-# details.
-#
-# You should have received a copy of the GNU Lesser General Public License
-# along with this library; if not, write to the Free Software Foundation, Inc.,
-# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
 
 SESSIOND_BIN="lttng-sessiond"
+SESSIOND_MATCH=".*lttng-sess.*"
 RUNAS_BIN="lttng-runas"
+RUNAS_MATCH=".*lttng-runas.*"
 CONSUMERD_BIN="lttng-consumerd"
+CONSUMERD_MATCH=".*lttng-consumerd.*"
 RELAYD_BIN="lttng-relayd"
+RELAYD_MATCH=".*lttng-relayd.*"
 LTTNG_BIN="lttng"
 BABELTRACE_BIN="babeltrace"
 OUTPUT_DEST=/dev/null
@@ -29,10 +21,12 @@ KERNEL_MAJOR_VERSION=2
 KERNEL_MINOR_VERSION=6
 KERNEL_PATCHLEVEL_VERSION=27
 
-# We set the default UST register timeout to "wait forever", so that
-# basic tests don't have to worry about hitting timeouts on busy
-# systems. Specialized tests should test those corner-cases.
+# We set the default UST register timeout and network and app socket timeout to
+# "wait forever", so that basic tests don't have to worry about hitting
+# timeouts on busy systems. Specialized tests should test those corner-cases.
 export LTTNG_UST_REGISTER_TIMEOUT=-1
+export LTTNG_NETWORK_SOCKET_TIMEOUT=-1
+export LTTNG_APP_SOCKET_TIMEOUT=-1
 
 # We set the default lttng-sessiond path to /bin/true to prevent the spawning
 # of a daemonized sessiond. This is necessary since 'lttng create' will spawn
@@ -42,6 +36,80 @@ export LTTNG_SESSIOND_PATH="/bin/true"
 
 source $TESTDIR/utils/tap/tap.sh
 
+if [ -z ${LTTNG_TEST_TEARDOWN_TIMEOUT+x} ]; then
+       LTTNG_TEST_TEARDOWN_TIMEOUT=60
+fi
+
+function full_cleanup ()
+{
+       # Try to kill daemons gracefully
+       stop_lttng_relayd_notap SIGTERM $LTTNG_TEST_TEARDOWN_TIMEOUT
+       stop_lttng_sessiond_notap SIGTERM $LTTNG_TEST_TEARDOWN_TIMEOUT
+
+       # If daemons are still present, forcibly kill them
+       stop_lttng_relayd_notap SIGKILL $LTTNG_TEST_TEARDOWN_TIMEOUT
+       stop_lttng_sessiond_notap SIGKILL $LTTNG_TEST_TEARDOWN_TIMEOUT
+       stop_lttng_consumerd_notap SIGKILL $LTTNG_TEST_TEARDOWN_TIMEOUT
+
+       # Disable trap for SIGTERM since the following kill to the
+       # pidgroup will be SIGTERM. Otherwise it loops.
+       # The '-' before the pid number ($$) indicates 'kill' to signal the
+       # whole process group.
+       trap - SIGTERM && kill -- -$$
+       exit 1
+}
+
+function null_pipes ()
+{
+       exec 0>/dev/null
+       exec 1>/dev/null
+       exec 2>/dev/null
+}
+
+trap full_cleanup SIGINT SIGTERM
+
+# perl prove closes its child pipes before giving it a chance to run its
+# signal trap handlers. Redirect pipes to /dev/null if SIGPIPE is caught
+# to allow those trap handlers to proceed.
+
+trap null_pipes SIGPIPE
+
+# Check pgrep from env, default to pgrep if none
+if [ -z "$PGREP" ]; then
+       PGREP=pgrep
+fi
+
+# Due to the renaming of threads we need to use the full command (pgrep -f) to
+# identify the pids for multiple lttng related processes. The problem with "pgrep
+# -f" is that it ends up also looking at the arguments. We use a two stage
+# lookup. The first one is using "pgrep -f" yielding potential candidate.
+# The second on perform grep on the basename of the first field of the
+# /proc/pid/cmdline of the previously identified pids. The first field
+# correspond to the actual command.
+function lttng_pgrep ()
+{
+       local pattern=$1
+       local possible_pids
+       local full_command_no_argument
+       local command_basename
+
+       possible_pids=$($PGREP -f "$pattern")
+       if [ -z "$possible_pids" ]; then
+               return 0
+       fi
+
+       while IFS= read -r pid ; do
+               # /proc/pid/cmdline is null separated.
+               if full_command_no_argument=$(cut -d '' -f 1 2>/dev/null < /proc/"$pid"/cmdline); then
+                       command_basename=$(basename "$full_command_no_argument")
+                       if grep -q "$pattern" <<< "$command_basename"; then
+                               echo "$pid"
+                       fi
+               fi
+       done <<< "$possible_pids"
+       return 0
+}
+
 function print_ok ()
 {
        # Check if we are a terminal
@@ -103,12 +171,32 @@ function conf_proc_count()
        echo
 }
 
+# Check if base lttng-modules are present.
+# Bail out on failure
+function validate_lttng_modules_present ()
+{
+       # Check for loadable modules.
+       modprobe -n lttng-tracer 2>/dev/null
+       if [ $? -eq 0 ]; then
+               return 0
+       fi
+
+       # Check for builtin modules.
+       ls /proc/lttng > /dev/null 2>&1
+       if [ $? -eq 0 ]; then
+               return 0
+       fi
+
+       BAIL_OUT "LTTng modules not detected."
+}
+
 function enable_kernel_lttng_event
 {
-       local expected_to_fail="$1"
-       local sess_name="$2"
-       local event_name="$3"
-       local channel_name="$4"
+       local withtap="$1"
+       local expected_to_fail="$2"
+       local sess_name="$3"
+       local event_name="$4"
+       local channel_name="$5"
 
        if [ -z "$event_name" ]; then
                # Enable all event if no event name specified
@@ -126,20 +214,30 @@ function enable_kernel_lttng_event
        ret=$?
        if [[ $expected_to_fail -eq "1" ]]; then
                test $ret -ne "0"
-               ok $? "Enable kernel event $event_name for session $session_name on channel $channel_name failed as expected"
+               ret=$?
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Enable kernel event $event_name for session $session_name on channel $channel_name failed as expected"
+               fi
        else
-               ok $ret "Enable kernel event $event_name for session $sess_name"
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Enable kernel event $event_name for session $sess_name"
+               fi
        fi
 }
 
 function enable_kernel_lttng_event_ok ()
 {
-       enable_kernel_lttng_event 0 "$@"
+       enable_kernel_lttng_event 0 "$@"
 }
 
 function enable_kernel_lttng_event_fail ()
 {
-       enable_kernel_lttng_event 1 "$@"
+       enable_kernel_lttng_event 1 1 "$@"
+}
+
+function enable_kernel_lttng_event_notap ()
+{
+       enable_kernel_lttng_event 0 0 "$@"
 }
 
 # Old interface
@@ -227,30 +325,104 @@ function lttng_disable_kernel_syscall_fail()
        lttng_disable_kernel_syscall 1 "$@"
 }
 
+function lttng_enable_kernel_function_event ()
+{
+       local expected_to_fail="$1"
+       local sess_name="$2"
+       local target="$3"
+       local event_name="$4"
+
+       "$TESTDIR/../src/bin/lttng/$LTTNG_BIN" enable-event --kernel --function="$target" "$event_name" -s "$sess_name" > "$OUTPUT_DEST" 2> "$ERROR_OUTPUT_DEST"
+       ret=$?
+       if [[ $expected_to_fail -eq "1" ]]; then
+               test $ret -ne "0"
+               ok $? "Enable kernel function event for session $sess_name failed as expected"
+       else
+               ok $ret "Enable kernel function event for session $sess_name"
+       fi
+}
+
+function lttng_enable_kernel_function_event_ok ()
+{
+       lttng_enable_kernel_function_event 0 "$@"
+}
+
+function lttng_enable_kernel_userspace_probe_event ()
+{
+       local expected_to_fail="$1"
+       local sess_name="$2"
+       local target="$3"
+       local event_name="$4"
+
+       "$TESTDIR/../src/bin/lttng/$LTTNG_BIN" enable-event --kernel --userspace-probe="$target" "$event_name" -s "$sess_name" > "$OUTPUT_DEST" 2> "$ERROR_OUTPUT_DEST"
+       ret=$?
+       if [[ $expected_to_fail -eq "1" ]]; then
+               test $ret -ne "0"
+               ok $? "Enable kernel userspace probe event for session $sess_name failed as expected"
+       else
+               ok $ret "Enable kernel userspace probe event for session $sess_name"
+       fi
+}
+
+function lttng_enable_kernel_userspace_probe_event_fail ()
+{
+       lttng_enable_kernel_userspace_probe_event 1 "$@"
+}
+
+function lttng_enable_kernel_userspace_probe_event_ok ()
+{
+       lttng_enable_kernel_userspace_probe_event 0 "$@"
+}
+
+function disable_kernel_lttng_userspace_probe_event_ok ()
+{
+       local sess_name="$1"
+       local event_name="$2"
+
+       "$TESTDIR/../src/bin/lttng/$LTTNG_BIN" disable-event --kernel "$event_name" -s "$sess_name" > "$OUTPUT_DEST" 2> "$ERROR_OUTPUT_DEST"
+       ok $? "Disable kernel event $target for session $sess_name"
+}
 function lttng_enable_kernel_channel()
 {
-       local expected_to_fail=$1
-       local sess_name=$2
-       local channel_name=$3
+       local withtap=$1
+       local expected_to_fail=$2
+       local sess_name=$3
+       local channel_name=$4
+       local opts="${@:5}"
 
-       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel -k $channel_name -s $sess_name 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel -k $channel_name -s $sess_name $opts 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ret=$?
        if [[ $expected_to_fail -eq "1" ]]; then
                test "$ret" -ne "0"
-               ok $? "Enable channel $channel_name for session $sess_name failed as expected"
+               ret=$?
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Enable channel $channel_name for session $sess_name failed as expected"
+               fi
        else
-               ok $ret "Enable channel $channel_name for session $sess_name"
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Enable channel $channel_name for session $sess_name"
+               fi
        fi
 }
 
 function lttng_enable_kernel_channel_ok()
 {
-       lttng_enable_kernel_channel 0 "$@"
+       lttng_enable_kernel_channel 0 "$@"
 }
 
 function lttng_enable_kernel_channel_fail()
 {
-       lttng_enable_kernel_channel 1 "$@"
+       lttng_enable_kernel_channel 1 1 "$@"
+}
+
+function lttng_enable_kernel_channel_notap()
+{
+       lttng_enable_kernel_channel 0 0 "$@"
+}
+
+function enable_kernel_lttng_channel_ok()
+{
+       lttng_enable_kernel_channel 1 0 "$@"
 }
 
 function lttng_disable_kernel_channel()
@@ -282,21 +454,23 @@ function lttng_disable_kernel_channel_fail()
 function start_lttng_relayd_opt()
 {
        local withtap=$1
-       local opt=$2
+       local process_mode=$2
+       local opt=$3
 
-       DIR=$(readlink -f $TESTDIR)
+       DIR=$(readlink -f "$TESTDIR")
 
-       if [ -z $(pgrep --full lt-$RELAYD_BIN) ]; then
-               $DIR/../src/bin/lttng-relayd/$RELAYD_BIN -b $opt 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       if [ -z $(lttng_pgrep "$RELAYD_MATCH") ]; then
+               # shellcheck disable=SC2086
+               $DIR/../src/bin/lttng-relayd/$RELAYD_BIN $process_mode $opt 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
                #$DIR/../src/bin/lttng-relayd/$RELAYD_BIN $opt -vvv >>/tmp/relayd.log 2>&1 &
                if [ $? -eq 1 ]; then
                        if [ $withtap -eq "1" ]; then
-                               fail "Start lttng-relayd (opt: $opt)"
+                               fail "Start lttng-relayd (process mode: $process_mode opt: $opt)"
                        fi
                        return 1
                else
                        if [ $withtap -eq "1" ]; then
-                               pass "Start lttng-relayd (opt: $opt)"
+                               pass "Start lttng-relayd (process mode: $process_mode opt: $opt)"
                        fi
                fi
        else
@@ -306,39 +480,69 @@ function start_lttng_relayd_opt()
 
 function start_lttng_relayd()
 {
-       start_lttng_relayd_opt 1 "$@"
+       start_lttng_relayd_opt 1 "-b" "$@"
 }
 
 function start_lttng_relayd_notap()
 {
-       start_lttng_relayd_opt 0 "$@"
+       start_lttng_relayd_opt 0 "-b" "$@"
 }
 
 function stop_lttng_relayd_opt()
 {
        local withtap=$1
+       local signal=$2
+
+       if [ -z "$signal" ]; then
+               signal="SIGTERM"
+       fi
 
-       PID_RELAYD=`pgrep --full lt-$RELAYD_BIN`
+       local timeout_s=$3
+       local dtimeleft_s=
 
-       if [ $withtap -eq "1" ]; then
-               diag "Killing lttng-relayd (pid: $PID_RELAYD)"
+       # Multiply time by 2 to simplify integer arithmetic
+       if [ -n "$timeout_s" ]; then
+               dtimeleft_s=$((timeout_s * 2))
        fi
-       kill $PID_RELAYD 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
-       retval=$?
 
-       if [ $? -eq 1 ]; then
-               if [ $withtap -eq "1" ]; then
+       local retval=0
+       local pids=
+
+       pids=$(lttng_pgrep "$RELAYD_MATCH")
+       if [ -z "$pids" ]; then
+               if [ "$withtap" -eq "1" ]; then
+                       pass "No relay daemon to kill"
+               fi
+               return 0
+       fi
+
+       diag "Killing (signal $signal) lttng-relayd (pid: $pids)"
+
+       # shellcheck disable=SC2086
+       if ! kill -s $signal $pids 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST; then
+               retval=1
+               if [ "$withtap" -eq "1" ]; then
                        fail "Kill relay daemon"
                fi
-               return 1
        else
                out=1
                while [ -n "$out" ]; do
-                       out=$(pgrep --full lt-$RELAYD_BIN)
+                       out=$(lttng_pgrep "$RELAYD_MATCH")
+                       if [ -n "$dtimeleft_s" ]; then
+                               if [ $dtimeleft_s -lt 0 ]; then
+                                       out=
+                                       retval=1
+                               fi
+                               dtimeleft_s=$((dtimeleft_s - 1))
+                       fi
                        sleep 0.5
                done
-               if [ $withtap -eq "1" ]; then
-                       pass "Kill relay daemon"
+               if [ "$withtap" -eq "1" ]; then
+                       if [ "$retval" -eq "0" ]; then
+                               pass "Wait after kill relay daemon"
+                       else
+                               fail "Wait after kill relay daemon"
+                       fi
                fi
        fi
        return $retval
@@ -361,31 +565,61 @@ function start_lttng_sessiond_opt()
        local withtap=$1
        local load_path=$2
 
-       if [ -n $TEST_NO_SESSIOND ] && [ "$TEST_NO_SESSIOND" == "1" ]; then
+       # The rest of the arguments will be passed directly to lttng-sessiond.
+       shift 2
+
+       local env_vars=""
+       local consumerd=""
+
+       local long_bit_value=
+       long_bit_value=$(getconf LONG_BIT)
+
+       if [ -n "$TEST_NO_SESSIOND" ] && [ "$TEST_NO_SESSIOND" == "1" ]; then
                # Env variable requested no session daemon
                return
        fi
 
-       validate_kernel_version
-       if [ $? -ne 0 ]; then
+       DIR=$(readlink -f "$TESTDIR")
+
+       # Get long_bit value for 32/64 consumerd
+       case "$long_bit_value" in
+               32)
+                       consumerd="--consumerd32-path=$DIR/../src/bin/lttng-consumerd/lttng-consumerd"
+                       ;;
+               64)
+                       consumerd="--consumerd64-path=$DIR/../src/bin/lttng-consumerd/lttng-consumerd"
+                       ;;
+               *)
+                       return
+                       ;;
+       esac
+
+       # Check for env. variable. Allow the use of LD_PRELOAD etc.
+       if [[ "x${LTTNG_SESSIOND_ENV_VARS}" != "x" ]]; then
+               env_vars="${LTTNG_SESSIOND_ENV_VARS} "
+       fi
+       env_vars="${env_vars}$DIR/../src/bin/lttng-sessiond/$SESSIOND_BIN"
+
+       if ! validate_kernel_version; then
            fail "Start session daemon"
            BAIL_OUT "*** Kernel too old for session daemon tests ***"
        fi
 
-       DIR=$(readlink -f $TESTDIR)
-       : ${LTTNG_SESSION_CONFIG_XSD_PATH=${DIR}/../src/common/config/}
+       : "${LTTNG_SESSION_CONFIG_XSD_PATH="${DIR}/../src/common/config/"}"
        export LTTNG_SESSION_CONFIG_XSD_PATH
 
-       if [ -z $(pgrep --full lt-$SESSIOND_BIN) ]; then
+       if [ -z "$(lttng_pgrep "${SESSIOND_MATCH}")" ]; then
                # Have a load path ?
                if [ -n "$load_path" ]; then
-                       $DIR/../src/bin/lttng-sessiond/$SESSIOND_BIN --load "$load_path" --background --consumerd32-path="$DIR/../src/bin/lttng-consumerd/lttng-consumerd" --consumerd64-path="$DIR/../src/bin/lttng-consumerd/lttng-consumerd"
+                       # shellcheck disable=SC2086
+                       env $env_vars --load "$load_path" --background "$consumerd" "$@"
                else
-                       $DIR/../src/bin/lttng-sessiond/$SESSIOND_BIN --background --consumerd32-path="$DIR/../src/bin/lttng-consumerd/lttng-consumerd" --consumerd64-path="$DIR/../src/bin/lttng-consumerd/lttng-consumerd"
+                       # shellcheck disable=SC2086
+                       env $env_vars --background "$consumerd" "$@"
                fi
                #$DIR/../src/bin/lttng-sessiond/$SESSIOND_BIN --background --consumerd32-path="$DIR/../src/bin/lttng-consumerd/lttng-consumerd" --consumerd64-path="$DIR/../src/bin/lttng-consumerd/lttng-consumerd" --verbose-consumer >>/tmp/sessiond.log 2>&1
                status=$?
-               if [ $withtap -eq "1" ]; then
+               if [ "$withtap" -eq "1" ]; then
                        ok $status "Start session daemon"
                fi
        fi
@@ -405,42 +639,100 @@ function stop_lttng_sessiond_opt()
 {
        local withtap=$1
        local signal=$2
-       local kill_opt=""
 
-       if [ -n $TEST_NO_SESSIOND ] && [ "$TEST_NO_SESSIOND" == "1" ]; then
+       if [ -z "$signal" ]; then
+               signal=SIGTERM
+       fi
+
+       local timeout_s=$3
+       local dtimeleft_s=
+
+       # Multiply time by 2 to simplify integer arithmetic
+       if [ -n "$timeout_s" ]; then
+               dtimeleft_s=$((timeout_s * 2))
+       fi
+
+       if [ -n "$TEST_NO_SESSIOND" ] && [ "$TEST_NO_SESSIOND" == "1" ]; then
                # Env variable requested no session daemon
-               return
+               return 0
        fi
 
-       PID_SESSIOND="$(pgrep --full lt-$SESSIOND_BIN) $(pgrep --full $RUNAS_BIN)"
+       local retval=0
 
-       if [ -n "$2" ]; then
-               kill_opt="$kill_opt -s $signal"
+       local runas_pids=
+       runas_pids=$(lttng_pgrep "$RUNAS_MATCH")
+
+       local pids=
+       pids=$(lttng_pgrep "$SESSIOND_MATCH")
+
+       if [ -n "$runas_pids" ]; then
+               pids="$pids $runas_pids"
        fi
-       if [ $withtap -eq "1" ]; then
-               diag "Killing lt-$SESSIOND_BIN pids: $(echo $PID_SESSIOND | tr '\n' ' ')"
+
+       if [ -z "$pids" ]; then
+               if [ "$withtap" -eq "1" ]; then
+                       fail "No session daemon to kill"
+               else
+                       BAIL_OUT "No session daemon to kill"
+               fi
+               return 0
        fi
-       kill $kill_opt $PID_SESSIOND 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
 
-       if [ $? -eq 1 ]; then
-               if [ $withtap -eq "1" ]; then
+       diag "Killing (signal $signal) $SESSIOND_BIN and lt-$SESSIOND_BIN pids: $(echo "$pids" | tr '\n' ' ')"
+
+       # shellcheck disable=SC2086
+       if ! kill -s $signal $pids 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST; then
+               retval=1
+               if [ "$withtap" -eq "1" ]; then
                        fail "Kill sessions daemon"
                fi
        else
                out=1
                while [ -n "$out" ]; do
-                       out=$(pgrep --full lt-$SESSIOND_BIN)
+                       out=$(lttng_pgrep "${SESSIOND_MATCH}")
+                       if [ -n "$dtimeleft_s" ]; then
+                               if [ $dtimeleft_s -lt 0 ]; then
+                                       out=
+                                       retval=1
+                               fi
+                               dtimeleft_s=$((dtimeleft_s - 1))
+                       fi
                        sleep 0.5
                done
                out=1
                while [ -n "$out" ]; do
-                       out=$(pgrep --full $CONSUMERD_BIN)
+                       out=$(lttng_pgrep "$CONSUMERD_MATCH")
+                       if [ -n "$dtimeleft_s" ]; then
+                               if [ $dtimeleft_s -lt 0 ]; then
+                                       out=
+                                       retval=1
+                               fi
+                               dtimeleft_s=$((dtimeleft_s - 1))
+                       fi
                        sleep 0.5
                done
-               if [ $withtap -eq "1" ]; then
-                       pass "Kill session daemon"
+
+               if [ "$withtap" -eq "1" ]; then
+                       if [ "$retval" -eq "0" ]; then
+                               pass "Wait after kill session daemon"
+                       else
+                               fail "Wait after kill session daemon"
+                       fi
+               fi
+       fi
+       if [ "$signal" = "SIGKILL" ]; then
+               if [ "$(id -u)" -eq "0" ]; then
+                       local modules=
+                       modules="$(lsmod | grep ^lttng | awk '{print $1}')"
+
+                       if [ -n "$modules" ]; then
+                               diag "Unloading all LTTng modules"
+                               modprobe --remove "$modules"
+                       fi
                fi
        fi
+
+       return $retval
 }
 
 function stop_lttng_sessiond()
@@ -457,43 +749,40 @@ function sigstop_lttng_sessiond_opt()
 {
        local withtap=$1
        local signal=SIGSTOP
-       local kill_opt=""
 
-       if [ -n $TEST_NO_SESSIOND ] && [ "$TEST_NO_SESSIOND" == "1" ]; then
+       if [ -n "$TEST_NO_SESSIOND" ] && [ "$TEST_NO_SESSIOND" == "1" ]; then
                # Env variable requested no session daemon
                return
        fi
 
-       PID_SESSIOND="$(pgrep --full lt-$SESSIOND_BIN) $(pgrep --full $RUNAS_BIN)"
+       PID_SESSIOND="$(lttng_pgrep "${SESSIOND_MATCH}") $(lttng_pgrep "$RUNAS_MATCH")"
 
-       kill_opt="$kill_opt -s $signal"
-
-       if [ $withtap -eq "1" ]; then
-               diag "Sending SIGSTOP to lt-$SESSIOND_BIN pids: $(echo $PID_SESSIOND | tr '\n' ' ')"
+       if [ "$withtap" -eq "1" ]; then
+               diag "Sending SIGSTOP to lt-$SESSIOND_BIN and $SESSIOND_BIN pids: $(echo "$PID_SESSIOND" | tr '\n' ' ')"
        fi
-       kill $kill_opt $PID_SESSIOND 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
 
-       if [ $? -eq 1 ]; then
-               if [ $withtap -eq "1" ]; then
+       # shellcheck disable=SC2086
+       if ! kill -s $signal $PID_SESSIOND 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST; then
+               if [ "$withtap" -eq "1" ]; then
                        fail "Sending SIGSTOP to session daemon"
                fi
        else
                out=1
                while [ $out -ne 0 ]; do
-                       pid=$(pgrep --full lt-$SESSIOND_BIN)
+                       pid="$(lttng_pgrep "$SESSIOND_MATCH")"
 
                        # Wait until state becomes stopped for session
                        # daemon(s).
                        out=0
                        for sessiond_pid in $pid; do
-                               state=$(ps -p $sessiond_pid -o state= )
+                               state="$(ps -p "$sessiond_pid" -o state= )"
                                if [[ -n "$state" && "$state" != "T" ]]; then
                                        out=1
                                fi
                        done
                        sleep 0.5
                done
-               if [ $withtap -eq "1" ]; then
+               if [ "$withtap" -eq "1" ]; then
                        pass "Sending SIGSTOP to session daemon"
                fi
        fi
@@ -513,46 +802,70 @@ function stop_lttng_consumerd_opt()
 {
        local withtap=$1
        local signal=$2
-       local kill_opt=""
 
-       PID_CONSUMERD=`pgrep --full $CONSUMERD_BIN`
+       if [ -z "$signal" ]; then
+               signal=SIGTERM
+       fi
+
+       local timeout_s=$3
+       local dtimeleft_s=
 
-       if [ -n "$2" ]; then
-               kill_opt="$kill_opt -s $signal"
+       # Multiply time by 2 to simplify integer arithmetic
+       if [ -n "$timeout_s" ]; then
+               dtimeleft_s=$((timeout_s * 2))
        fi
 
-       if [ $withtap -eq "1" ]; then
-               diag "Killing $CONSUMERD_BIN pids: $(echo $PID_CONSUMERD | tr '\n' ' ')"
+       local retval=0
+
+       PID_CONSUMERD="$(lttng_pgrep "$CONSUMERD_MATCH")"
+
+       if [ -z "$PID_CONSUMERD" ]; then
+               if [ "$withtap" -eq "1" ]; then
+                       pass "No consumer daemon to kill"
+               fi
+               return 0
        fi
-       kill $kill_opt $PID_CONSUMERD 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
-       retval=$?
-       set +x
 
-       if [ $? -eq 1 ]; then
-               if [ $withtap -eq "1" ]; then
+       diag "Killing (signal $signal) $CONSUMERD_BIN pids: $(echo "$PID_CONSUMERD" | tr '\n' ' ')"
+
+       # shellcheck disable=SC2086
+       if ! kill -s $signal $PID_CONSUMERD 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST; then
+               retval=1
+               if [ "$withtap" -eq "1" ]; then
                        fail "Kill consumer daemon"
                fi
-               return 1
        else
                out=1
                while [ $out -ne 0 ]; do
-                       pid=$(pgrep --full $CONSUMERD_BIN)
+                       pid="$(lttng_pgrep "$CONSUMERD_MATCH")"
 
                        # If consumerds are still present check their status.
                        # A zombie status qualifies the consumerd as *killed*
                        out=0
                        for consumer_pid in $pid; do
-                               state=$(ps -p $consumer_pid -o state= )
+                               state="$(ps -p "$consumer_pid" -o state= )"
                                if [[ -n "$state" && "$state" != "Z" ]]; then
                                        out=1
                                fi
                        done
+                       if [ -n "$dtimeleft_s" ]; then
+                               if [ $dtimeleft_s -lt 0 ]; then
+                                       out=0
+                                       retval=1
+                               fi
+                               dtimeleft_s=$((dtimeleft_s - 1))
+                       fi
                        sleep 0.5
                done
-               if [ $withtap -eq "1" ]; then
-                       pass "Kill consumer daemon"
+               if [ "$withtap" -eq "1" ]; then
+                       if [ "$retval" -eq "0" ]; then
+                               pass "Wait after kill consumer daemon"
+                       else
+                               fail "Wait after kill consumer daemon"
+                       fi
                fi
        fi
+
        return $retval
 }
 
@@ -570,41 +883,37 @@ function sigstop_lttng_consumerd_opt()
 {
        local withtap=$1
        local signal=SIGSTOP
-       local kill_opt=""
 
-       PID_CONSUMERD=`pgrep --full $CONSUMERD_BIN`
+       PID_CONSUMERD="$(lttng_pgrep "$CONSUMERD_MATCH")"
 
-       kill_opt="$kill_opt -s $signal"
+       diag "Sending SIGSTOP to $CONSUMERD_BIN pids: $(echo "$PID_CONSUMERD" | tr '\n' ' ')"
 
-       if [ $withtap -eq "1" ]; then
-               diag "Sending SIGSTOP to $CONSUMERD_BIN pids: $(echo $PID_CONSUMERD | tr '\n' ' ')"
-       fi
-       kill $kill_opt $PID_CONSUMERD 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       # shellcheck disable=SC2086
+       kill -s $signal $PID_CONSUMERD 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        retval=$?
-       set +x
 
-       if [ $? -eq 1 ]; then
-               if [ $withtap -eq "1" ]; then
+       if [ $retval -eq 1 ]; then
+               if [ "$withtap" -eq "1" ]; then
                        fail "Sending SIGSTOP to consumer daemon"
                fi
                return 1
        else
                out=1
                while [ $out -ne 0 ]; do
-                       pid=$(pgrep --full $CONSUMERD_BIN)
+                       pid="$(lttng_pgrep "$CONSUMERD_MATCH")"
 
                        # Wait until state becomes stopped for all
                        # consumers.
                        out=0
                        for consumer_pid in $pid; do
-                               state=$(ps -p $consumer_pid -o state= )
+                               state="$(ps -p "$consumer_pid" -o state= )"
                                if [[ -n "$state" && "$state" != "T" ]]; then
                                        out=1
                                fi
                        done
                        sleep 0.5
                done
-               if [ $withtap -eq "1" ]; then
+               if [ "$withtap" -eq "1" ]; then
                        pass "Sending SIGSTOP to consumer daemon"
                fi
        fi
@@ -631,64 +940,105 @@ function list_lttng_with_opts ()
 function create_lttng_session_no_output ()
 {
        local sess_name=$1
+       local opts="${@:2}"
 
-       $TESTDIR/../src/bin/lttng/$LTTNG_BIN create $sess_name --no-output 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN create $sess_name --no-output $opts 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ok $? "Create session $sess_name in no-output mode"
 }
 
+function create_lttng_session_uri () {
+       local sess_name=$1
+       local uri=$2
+       local opts="${@:3}"
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN create $sess_name -U $uri $opts 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ok $? "Create session $sess_name with uri:$uri and opts: $opts"
+}
+
 function create_lttng_session ()
 {
-       local expected_to_fail=$1
-       local sess_name=$2
-       local trace_path=$3
-       local opt=$4
+       local withtap=$1
+       local expected_to_fail=$2
+       local sess_name=$3
+       local trace_path=$4
+       local opt=$5
+
+       if [ -z "$trace_path" ]; then
+               # Use lttng-sessiond default output.
+               trace_path=""
+       else
+               trace_path="-o $trace_path"
+       fi
 
-       $TESTDIR/../src/bin/lttng/$LTTNG_BIN create $sess_name -o $trace_path $opt > $OUTPUT_DEST
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN create "$sess_name" $trace_path $opt 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ret=$?
-       if [[ $expected_to_fail -eq "1" ]]; then
+       if [ $expected_to_fail -eq "1" ]; then
                test "$ret" -ne "0"
-               ok $? "Create session $sess_name in $trace_path failed as expected"
+               ret=$?
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Create session $sess_name in $trace_path failed as expected"
+               fi
        else
-               ok $ret "Create session $sess_name in $trace_path"
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Create session $sess_name in $trace_path"
+               fi
        fi
+       return $ret
 }
 
 function create_lttng_session_ok ()
 {
-       create_lttng_session 0 "$@"
+       create_lttng_session 0 "$@"
 }
 
 function create_lttng_session_fail ()
 {
-       create_lttng_session 1 "$@"
+       create_lttng_session 1 1 "$@"
+}
+
+function create_lttng_session_notap ()
+{
+       create_lttng_session 0 0 "$@"
 }
 
 
 function enable_ust_lttng_channel ()
 {
-       local expected_to_fail=$1
-       local sess_name=$2
-       local channel_name=$3
-       local opt=$4
+       local withtap=$1
+       local expected_to_fail=$2
+       local sess_name=$3
+       local channel_name=$4
+       local opts="${@:5}"
 
-       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel -u $channel_name -s $sess_name $opt 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel -u $channel_name -s $sess_name $opts 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ret=$?
        if [[ $expected_to_fail -eq "1" ]]; then
                test "$ret" -ne "0"
-               ok $? "Enable channel $channel_name for session $sess_name failed as expected"
+               ret=$?
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Enable channel $channel_name for session $sess_name failed as expected"
+               fi
        else
-               ok $ret "Enable channel $channel_name for session $sess_name"
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Enable channel $channel_name for session $sess_name"
+               fi
        fi
+       return $ret
 }
 
 function enable_ust_lttng_channel_ok ()
 {
-       enable_ust_lttng_channel 0 "$@"
+       enable_ust_lttng_channel 0 "$@"
 }
 
 function enable_ust_lttng_channel_fail ()
 {
-       enable_ust_lttng_channel 1 "$@"
+       enable_ust_lttng_channel 1 1 "$@"
+}
+
+function enable_ust_lttng_channel_notap ()
+{
+       enable_ust_lttng_channel 0 0 "$@"
 }
 
 function disable_ust_lttng_channel()
@@ -709,6 +1059,24 @@ function enable_lttng_mmap_overwrite_kernel_channel()
        ok $? "Enable channel $channel_name for session $sess_name"
 }
 
+function enable_lttng_mmap_discard_small_kernel_channel()
+{
+       local sess_name=$1
+       local channel_name=$2
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel -s $sess_name $channel_name -k --output mmap --discard --subbuf-size=$(getconf PAGE_SIZE) --num-subbuf=2 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ok $? "Enable small discard channel $channel_name for session $sess_name"
+}
+
+function enable_lttng_mmap_overwrite_small_kernel_channel()
+{
+       local sess_name=$1
+       local channel_name=$2
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel -s $sess_name $channel_name -k --output mmap --overwrite --subbuf-size=$(getconf PAGE_SIZE) --num-subbuf=2 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ok $? "Enable small discard channel $channel_name for session $sess_name"
+}
+
 function enable_lttng_mmap_overwrite_ust_channel()
 {
        local sess_name=$1
@@ -720,10 +1088,11 @@ function enable_lttng_mmap_overwrite_ust_channel()
 
 function enable_ust_lttng_event ()
 {
-       local expected_to_fail=$1
-       local sess_name=$2
-       local event_name="$3"
-       local channel_name=$4
+       local withtap=$1
+       local expected_to_fail=$2
+       local sess_name=$3
+       local event_name="$4"
+       local channel_name=$5
 
        if [ -z $channel_name ]; then
                # default channel if none specified
@@ -736,20 +1105,31 @@ function enable_ust_lttng_event ()
        ret=$?
        if [[ $expected_to_fail -eq "1" ]]; then
                test $ret -ne "0"
-               ok $? "Enable ust event $event_name for session $session_name failed as expected"
+               ret=$?
+               if [[ $withtap -eq "1" ]]; then
+                       ok $ret "Enable ust event $event_name for session $session_name failed as expected"
+               fi
        else
-               ok $ret "Enable ust event $event_name for session $sess_name"
+               if [[ $withtap -eq "1" ]]; then
+                       ok $ret "Enable ust event $event_name for session $sess_name"
+               fi
        fi
+       return $ret
 }
 
 function enable_ust_lttng_event_ok ()
 {
-       enable_ust_lttng_event 0 "$@"
+       enable_ust_lttng_event 0 "$@"
 }
 
 function enable_ust_lttng_event_fail ()
 {
-       enable_ust_lttng_event 1 "$@"
+       enable_ust_lttng_event 1 1 "$@"
+}
+
+function enable_ust_lttng_event_notap ()
+{
+       enable_ust_lttng_event 0 0 "$@"
 }
 
 function enable_jul_lttng_event()
@@ -862,8 +1242,16 @@ function enable_ust_lttng_event_filter()
        local sess_name="$1"
        local event_name="$2"
        local filter="$3"
+       local channel_name=$4
+
+       if [ -z $channel_name ]; then
+               # default channel if none specified
+               chan=""
+       else
+               chan="-c $channel_name"
+       fi
 
-       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-event "$event_name" -s $sess_name -u --filter "$filter" 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-event $chan "$event_name" -s $sess_name -u --filter "$filter" 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ok $? "Enable event $event_name with filtering for session $sess_name"
 }
 
@@ -931,82 +1319,114 @@ function disable_python_lttng_event ()
        ok $? "Disable Python event $event_name for session $sess_name"
 }
 
-function start_lttng_tracing ()
+function start_lttng_tracing_opt ()
 {
-       local expected_to_fail=$1
-       local sess_name=$2
+       local withtap=$1
+       local expected_to_fail=$2
+       local sess_name=$3
 
        $TESTDIR/../src/bin/lttng/$LTTNG_BIN start $sess_name 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ret=$?
        if [[ $expected_to_fail -eq "1" ]]; then
                test "$ret" -ne "0"
-               ok $? "Start tracing for session $sess_name failed as expected"
+               ret=$?
+               if [ $withtap -eq "1" ]; then
+                       ok $? "Start tracing for session $sess_name failed as expected"
+               fi
        else
-               ok $ret "Start tracing for session $sess_name"
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Start tracing for session $sess_name"
+               fi
        fi
 }
 
 function start_lttng_tracing_ok ()
 {
-       start_lttng_tracing 0 "$@"
+       start_lttng_tracing_opt 1 0 "$@"
 }
 
 function start_lttng_tracing_fail ()
 {
-       start_lttng_tracing 1 "$@"
+       start_lttng_tracing_opt 1 1 "$@"
 }
 
-function stop_lttng_tracing ()
+function start_lttng_tracing_notap ()
 {
-       local expected_to_fail=$1
-       local sess_name=$2
+       start_lttng_tracing_opt 0 1 "$@"
+}
+
+function stop_lttng_tracing_opt ()
+{
+       local withtap=$1
+       local expected_to_fail=$2
+       local sess_name=$3
 
        $TESTDIR/../src/bin/lttng/$LTTNG_BIN stop $sess_name 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ret=$?
        if [[ $expected_to_fail -eq "1" ]]; then
                test "$ret" -ne "0"
-               ok $? "Stop lttng tracing for session $sess_name failed as expected"
+               ret=$?
+               if [ $withtap -eq "1" ]; then
+                       ok $? "Stop lttng tracing for session $sess_name failed as expected"
+               fi
        else
-               ok $ret "Stop lttng tracing for session $sess_name"
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Stop lttng tracing for session $sess_name"
+               fi
        fi
 }
 
 function stop_lttng_tracing_ok ()
 {
-       stop_lttng_tracing 0 "$@"
+       stop_lttng_tracing_opt 1 0 "$@"
 }
 
 function stop_lttng_tracing_fail ()
 {
-       stop_lttng_tracing 1 "$@"
+       stop_lttng_tracing_opt 1 1 "$@"
+}
+
+function stop_lttng_tracing_notap ()
+{
+       stop_lttng_tracing_opt 0 0 "$@"
 }
 
 function destroy_lttng_session ()
 {
-       local expected_to_fail=$1
-       local sess_name=$2
+       local withtap=$1
+       local expected_to_fail=$2
+       local sess_name=$3
 
        $TESTDIR/../src/bin/lttng/$LTTNG_BIN destroy $sess_name 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ret=$?
        if [[ $expected_to_fail -eq "1" ]]; then
                test "$ret" -ne "0"
-               ok $? "Destroy session $sess_name failed as expected"
+               ret=$?
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Destroy session $sess_name failed as expected"
+               fi
        else
-               ok $ret "Destroy session $sess_name"
+               if [ $withtap -eq "1" ]; then
+                       ok $ret "Destroy session $sess_name"
+               fi
        fi
 }
 
 function destroy_lttng_session_ok ()
 {
-       destroy_lttng_session 0 "$@"
+       destroy_lttng_session 0 "$@"
 
 }
 
 function destroy_lttng_session_fail ()
 {
-       destroy_lttng_session 1 "$@"
+       destroy_lttng_session 1 "$@"
 }
 
+function destroy_lttng_session_notap ()
+{
+       destroy_lttng_session 0 0 "$@"
+}
 
 function destroy_lttng_sessions ()
 {
@@ -1019,14 +1439,15 @@ function lttng_snapshot_add_output ()
        local expected_to_fail=$1
        local sess_name=$2
        local trace_path=$3
+       local opts=$4
 
-       $TESTDIR/../src/bin/lttng/$LTTNG_BIN snapshot add-output -s $sess_name file://$trace_path 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN snapshot add-output -s $sess_name $trace_path $opts 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ret=$?
        if [[ $expected_to_fail -eq 1 ]]; then
                test "$ret" -ne "0"
-               ok $? "Added snapshot output file://$trace_path failed as expected"
+               ok $? "Added snapshot output $trace_path failed as expected"
        else
-               ok $ret "Added snapshot output file://$trace_path"
+               ok $ret "Added snapshot output $trace_path"
        fi
 }
 
@@ -1069,9 +1490,8 @@ function lttng_snapshot_del_output_fail ()
 function lttng_snapshot_record ()
 {
        local sess_name=$1
-       local trace_path=$2
 
-       $TESTDIR/../src/bin/lttng/$LTTNG_BIN snapshot record -s $sess_name 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN snapshot record -s $sess_name $trace_path 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ok $? "Snapshot recorded"
 }
 
@@ -1093,16 +1513,34 @@ function lttng_save()
 
 function lttng_load()
 {
-       local opts=$1
+       local expected_to_fail=$1
+       local opts=$2
 
        $TESTDIR/../src/bin/lttng/$LTTNG_BIN load $opts 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
-       ok $? "Load command with opts: $opts"
+       ret=$?
+       if [[ $expected_to_fail -eq "1" ]]; then
+               test $ret -ne "0"
+               ok $? "Load command failed as expected with opts: $opts"
+       else
+               ok $ret "Load command with opts: $opts"
+       fi
+}
+
+function lttng_load_ok()
+{
+       lttng_load 0 "$@"
+}
+
+function lttng_load_fail()
+{
+       lttng_load 1 "$@"
 }
 
 function lttng_track()
 {
-       local expected_to_fail=$1
-       local opts=$2
+       local expected_to_fail="$1"
+       shift 1
+       local opts="$@"
        $TESTDIR/../src/bin/lttng/$LTTNG_BIN track $opts >$OUTPUT_DEST
        ret=$?
        if [[ $expected_to_fail -eq "1" ]]; then
@@ -1125,8 +1563,9 @@ function lttng_track_fail()
 
 function lttng_untrack()
 {
-       local expected_to_fail=$1
-       local opts=$2
+       local expected_to_fail="$1"
+       shift 1
+       local opts="$@"
        $TESTDIR/../src/bin/lttng/$LTTNG_BIN untrack $opts >$OUTPUT_DEST
        ret=$?
        if [[ $expected_to_fail -eq "1" ]]; then
@@ -1147,6 +1586,66 @@ function lttng_untrack_fail()
        lttng_untrack 1 "$@"
 }
 
+function lttng_track_pid_ok()
+{
+       PID=$1
+       "$TESTDIR/../src/bin/lttng/$LTTNG_BIN" track --kernel --pid=$PID 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ok $? "Lttng track pid on the kernel domain"
+}
+
+function lttng_untrack_kernel_all_ok()
+{
+       "$TESTDIR/../src/bin/lttng/$LTTNG_BIN" untrack --kernel --pid --all 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ok $? "Lttng untrack all pid on the kernel domain"
+}
+
+function lttng_track_ust_ok()
+{
+       lttng_track_ok -u "$@"
+}
+
+function lttng_track_ust_fail()
+{
+       lttng_track_fail -u "$@"
+}
+
+function lttng_track_kernel_ok()
+{
+       lttng_track_ok -k "$@"
+}
+
+function lttng_track_kernel_fail()
+{
+       lttng_track_fail -k "$@"
+}
+
+function lttng_untrack_ust_ok()
+{
+       lttng_untrack_ok -u "$@"
+}
+
+function lttng_untrack_ust_fail()
+{
+       lttng_untrack_fail -u "$@"
+}
+
+function lttng_untrack_kernel_ok()
+{
+       lttng_untrack_ok -k "$@"
+}
+
+function lttng_untrack_kernel_fail()
+{
+       lttng_untrack_fail -k "$@"
+}
+
+function lttng_add_context_list()
+{
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN add-context --list 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ret=$?
+       ok $ret "Context listing"
+}
+
 function add_context_lttng()
 {
        local expected_to_fail="$1"
@@ -1185,6 +1684,55 @@ function add_context_kernel_fail()
        add_context_lttng 1 -k "$@"
 }
 
+function wait_live_trace_ready ()
+{
+       local url=$1
+       local zero_client_match=0
+
+       diag "Waiting for live trace at url: $url"
+       while [ $zero_client_match -eq 0 ]; do
+               zero_client_match=$($BABELTRACE_BIN -i lttng-live $url | grep "0 client(s) connected" | wc -l)
+               sleep 0.5
+       done
+       pass "Waiting for live trace at url: $url"
+}
+
+function wait_live_viewer_connect ()
+{
+       local url=$1
+       local one_client_match=0
+
+       diag "Waiting for live viewers on url: $url"
+       while [ $one_client_match -eq 0 ]; do
+               one_client_match=$($BABELTRACE_BIN -i lttng-live $url | grep "1 client(s) connected" | wc -l)
+               sleep 0.5
+       done
+       pass "Waiting for live viewers on url: $url"
+}
+
+function validate_metadata_event ()
+{
+       local event_name=$1
+       local nr_event_id=$2
+       local trace_path=$3
+
+       local metadata_file=$(find $trace_path | grep metadata)
+       local metadata_path=$(dirname $metadata_file)
+
+       which $BABELTRACE_BIN >/dev/null
+       skip $? -ne 0 "Babeltrace binary not found. Skipping trace matches"
+
+       local count=$($BABELTRACE_BIN --output-format=ctf-metadata $metadata_path | grep $event_name | wc -l)
+
+       if [ "$count" -ne "$nr_event_id" ]; then
+               fail "Metadata match with the metadata of $count event(s) named $event_name"
+               diag "$count matching event id found in metadata"
+       else
+               pass "Metadata match with the metadata of $count event(s) named $event_name"
+       fi
+
+}
+
 function trace_matches ()
 {
        local event_name=$1
@@ -1198,7 +1746,7 @@ function trace_matches ()
 
        if [ "$count" -ne "$nr_iter" ]; then
                fail "Trace match"
-               diag "$count events found in trace"
+               diag "$count matching events found in trace"
        else
                pass "Trace match"
        fi
@@ -1216,12 +1764,12 @@ function trace_match_only()
        local count=$($BABELTRACE_BIN $trace_path | grep $event_name | wc -l)
        local total=$($BABELTRACE_BIN $trace_path | wc -l)
 
-    if [ "$nr_iter" -eq "$count" ] && [ "$total" -eq "$nr_iter" ]; then
-        pass "Trace match with $total event $event_name"
-    else
-        fail "Trace match"
-        diag "$total event(s) found, expecting $nr_iter of event $event_name and only found $count"
-    fi
+       if [ "$nr_iter" -eq "$count" ] && [ "$total" -eq "$nr_iter" ]; then
+               pass "Trace match with $total event $event_name"
+       else
+               fail "Trace match"
+               diag "$total event(s) found, expecting $nr_iter of event $event_name and only found $count"
+       fi
 }
 
 function validate_trace
@@ -1250,6 +1798,77 @@ function validate_trace
        return $ret
 }
 
+function validate_trace_count
+{
+       local event_name=$1
+       local trace_path=$2
+       local expected_count=$3
+
+       which $BABELTRACE_BIN >/dev/null
+       if [ $? -ne 0 ]; then
+           skip 0 "Babeltrace binary not found. Skipping trace validation"
+       fi
+
+       cnt=0
+       OLDIFS=$IFS
+       IFS=","
+       for i in $event_name; do
+               traced=$($BABELTRACE_BIN $trace_path 2>/dev/null | grep $i | wc -l)
+               if [ "$traced" -ne 0 ]; then
+                       pass "Validate trace for event $i, $traced events"
+               else
+                       fail "Validate trace for event $i"
+                       diag "Found $traced occurences of $i"
+               fi
+               cnt=$(($cnt + $traced))
+       done
+       IFS=$OLDIFS
+       test $cnt -eq $expected_count
+       ok $? "Read a total of $cnt events, expected $expected_count"
+}
+
+function validate_trace_count_range_incl_min_excl_max
+{
+       local event_name=$1
+       local trace_path=$2
+       local expected_min=$3
+       local expected_max=$4
+
+       which $BABELTRACE_BIN >/dev/null
+       if [ $? -ne 0 ]; then
+           skip 0 "Babeltrace binary not found. Skipping trace validation"
+       fi
+
+       cnt=0
+       OLDIFS=$IFS
+       IFS=","
+       for i in $event_name; do
+               traced=$($BABELTRACE_BIN $trace_path 2>/dev/null | grep $i | wc -l)
+               if [ "$traced" -ge $expected_min ]; then
+                       pass "Validate trace for event $i, $traced events"
+               else
+                       fail "Validate trace for event $i"
+                       diag "Found $traced occurences of $i"
+               fi
+               cnt=$(($cnt + $traced))
+       done
+       IFS=$OLDIFS
+       test $cnt -lt $expected_max
+       ok $? "Read a total of $cnt events, expected between [$expected_min, $expected_max["
+}
+
+function trace_first_line
+{
+       local trace_path=$1
+
+       which $BABELTRACE_BIN >/dev/null
+       if [ $? -ne 0 ]; then
+           skip 0 "Babeltrace binary not found. Skipping trace validation"
+       fi
+
+       $BABELTRACE_BIN $trace_path 2>/dev/null | head -n 1
+}
+
 function validate_trace_exp()
 {
        local event_exp=$1
@@ -1258,7 +1877,7 @@ function validate_trace_exp()
        which $BABELTRACE_BIN >/dev/null
        skip $? -ne 0 "Babeltrace binary not found. Skipping trace validation"
 
-       traced=$($BABELTRACE_BIN $trace_path 2>/dev/null | grep ${event_exp} | wc -l)
+       traced=$($BABELTRACE_BIN $trace_path 2>/dev/null | grep --extended-regexp ${event_exp} | wc -l)
        if [ "$traced" -ne 0 ]; then
                pass "Validate trace for expression '${event_exp}', $traced events"
        else
@@ -1277,11 +1896,11 @@ function validate_trace_only_exp()
        which $BABELTRACE_BIN >/dev/null
        skip $? -ne 0 "Babeltrace binary not found. Skipping trace matches"
 
-       local count=$($BABELTRACE_BIN $trace_path | grep ${event_exp} | wc -l)
+       local count=$($BABELTRACE_BIN $trace_path | grep --extended-regexp ${event_exp} | wc -l)
        local total=$($BABELTRACE_BIN $trace_path | wc -l)
 
        if [ "$count" -ne 0 ] && [ "$total" -eq "$count" ]; then
-               pass "Trace match with $total for expression '${event_exp}"
+               pass "Trace match with $total for expression '${event_exp}'"
        else
                fail "Trace match"
                diag "$total syscall event(s) found, only syscalls matching expression '${event_exp}' ($count occurrences) are expected"
@@ -1299,7 +1918,14 @@ function validate_trace_empty()
            skip 0 "Babeltrace binary not found. Skipping trace validation"
        fi
 
-       traced=$($BABELTRACE_BIN $trace_path 2>/dev/null | wc -l)
+       events=$($BABELTRACE_BIN $trace_path 2>/dev/null)
+       ret=$?
+       if [ $ret -ne 0 ]; then
+               fail "Failed to parse trace"
+               return $ret
+       fi
+
+       traced=$(echo -n "$events" | wc -l)
        if [ "$traced" -eq 0 ]; then
                pass "Validate empty trace"
        else
@@ -1310,27 +1936,242 @@ function validate_trace_empty()
        return $ret
 }
 
-function metadata_regenerate ()
+function validate_directory_empty ()
+{
+       local trace_path="$1"
+
+       # Do not double quote `$trace_path` below as we want wildcards to be
+       # expanded.
+       files="$(ls -A $trace_path)"
+       ret=$?
+       if [ $ret -ne 0 ]; then
+               fail "Failed to list content of directory \"$trace_path\""
+               return $ret
+       fi
+
+       nb_files="$(echo -n "$files" | wc -l)"
+       ok $nb_files "Directory \"$trace_path\" is empty"
+}
+
+function validate_trace_session_ust_empty()
+{
+       validate_directory_empty "$1"/ust
+}
+
+function validate_trace_session_kernel_empty()
+{
+       validate_trace_empty "$1"/kernel
+}
+
+function regenerate_metadata ()
 {
        local expected_to_fail=$1
        local sess_name=$2
 
-       $TESTDIR/../src/bin/lttng/$LTTNG_BIN metadata regenerate -s $sess_name 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN regenerate metadata -s $sess_name 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
        ret=$?
        if [[ $expected_to_fail -eq "1" ]]; then
                test "$ret" -ne "0"
-               ok $? "Expected fail on regenerate $sess_name"
+               ok $? "Expected fail on regenerate metadata $sess_name"
        else
                ok $ret "Metadata regenerate $sess_name"
        fi
 }
 
-function metadata_regenerate_ok ()
+function regenerate_metadata_ok ()
+{
+       regenerate_metadata 0 "$@"
+}
+
+function regenerate_metadata_fail ()
+{
+       regenerate_metadata 1 "$@"
+}
+
+function regenerate_statedump ()
+{
+       local expected_to_fail=$1
+       local sess_name=$2
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN regenerate statedump -s $sess_name 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ret=$?
+       if [[ $expected_to_fail -eq "1" ]]; then
+               test "$ret" -ne "0"
+               ok $? "Expected fail on regenerate statedump $sess_name"
+       else
+               ok $ret "Statedump regenerate $sess_name"
+       fi
+}
+
+function regenerate_statedump_ok ()
+{
+       regenerate_statedump 0 "$@"
+}
+
+function regenerate_statedump_fail ()
+{
+       regenerate_statedump 1 "$@"
+}
+
+function rotate_session ()
+{
+       local expected_to_fail=$1
+       local sess_name=$2
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN rotate $sess_name 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ret=$?
+       if [[ $expected_to_fail -eq "1" ]]; then
+               test "$ret" -ne "0"
+               ok $? "Expected fail on rotate session $sess_name"
+       else
+               ok $ret "Rotate session $sess_name"
+       fi
+}
+
+function rotate_session_ok ()
+{
+       rotate_session 0 "$@"
+}
+
+function rotate_session_fail ()
+{
+       rotate_session 1 "$@"
+}
+
+function destructive_tests_enabled ()
+{
+       if [ ${LTTNG_ENABLE_DESTRUCTIVE_TESTS} = "will-break-my-system" ]; then
+               return 0
+       else
+               return 1
+       fi
+}
+
+function lttng_enable_rotation_timer ()
+{
+       local expected_to_fail=$1
+       local sess_name=$2
+       local period=$3
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-rotation -s $sess_name --timer $period 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ret=$?
+       if [[ $expected_to_fail -eq "1" ]]; then
+               test "$ret" -ne "0"
+               ok $? "Expected fail when setting periodic rotation ($period) of session $sess_name"
+       else
+               ok $ret "Set periodic rotation ($period) of session $sess_name"
+       fi
+}
+
+function lttng_enable_rotation_timer_ok ()
+{
+       lttng_enable_rotation_timer 0 $@
+}
+
+function lttng_enable_rotation_timer_fail ()
+{
+       lttng_enable_rotation_timer 1 $@
+}
+
+function lttng_enable_rotation_size ()
+{
+       local expected_to_fail=$1
+       local sess_name=$2
+       local size=$3
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-rotation -s $sess_name --size $size 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ret=$?
+       if [[ $expected_to_fail -eq "1" ]]; then
+               test "$ret" -ne "0"
+               ok $? "Expected fail on rotate session $sess_name"
+       else
+               ok $ret "Rotate session $sess_name"
+       fi
+}
+
+function lttng_enable_rotation_size_ok ()
+{
+       lttng_enable_rotation_size 0 $@
+}
+
+function lttng_enable_rotation_size_fail ()
+{
+       lttng_enable_rotation_size 1 $@
+}
+
+function lttng_clear_session ()
+{
+       local expected_to_fail=$1
+       local sess_name=$2
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN clear $sess_name 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ret=$?
+       if [[ $expected_to_fail -eq "1" ]]; then
+               test "$ret" -ne "0"
+               ok $? "Expected fail on clear session $sess_name"
+       else
+               ok $ret "Clear session $sess_name"
+       fi
+}
+
+function lttng_clear_session_ok ()
+{
+       lttng_clear_session 0 $@
+}
+
+function lttng_clear_session_fail ()
+{
+       lttng_clear_session 1 $@
+}
+
+function lttng_clear_all ()
+{
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN clear --all 1> $OUTPUT_DEST 2> $ERROR_OUTPUT_DEST
+       ok $? "Clear all lttng sessions"
+}
+
+function lttng_add_trigger()
+{
+       local expected_to_fail="$1"
+       local trigger_name="$2"
+       shift 2
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN add-trigger --id "$trigger_name" "$@" 1> /dev/null 2> /dev/null
+       ret=$?
+       if [[ $expected_to_fail -eq "1" ]]; then
+               test "$ret" -ne "0"
+               ok $? "Add trigger $trigger_name failed as expected"
+       else
+               ok $ret "Add trigger $trigger_name"
+       fi
+}
+
+function lttng_remove_trigger()
+{
+       local expected_to_fail="$1"
+       local trigger_name="$2"
+
+       $TESTDIR/../src/bin/lttng/$LTTNG_BIN remove-trigger "$trigger_name" 1> /dev/null 2> /dev/null
+       ret=$?
+       if [[ $expected_to_fail -eq "1" ]]; then
+               test "$ret" -ne "0"
+               ok $? "Remove trigger $trigger_name failed as expected"
+       else
+               ok $ret "Remove trigger $trigger_name"
+       fi
+}
+
+function lttng_add_trigger_ok()
+{
+       lttng_add_trigger 0 "$@"
+}
+
+function lttng_add_trigger_fail()
 {
-       metadata_regenerate 0 "$@"
+       lttng_add_trigger 1 "$@"
 }
 
-function metadata_regenerate_fail ()
+function lttng_remove_trigger_ok()
 {
-       metadata_regenerate 1 "$@"
+       lttng_remove_trigger 0 "$@"
 }
This page took 0.042966 seconds and 4 git commands to generate.